/*   
     
Ec    Copyright (C)   2001 Marc Dechico


      ec_eva.h :  compute the datas collected during the simulation 
                (exploration of the game tree) 
		automat to find bugs in the engine (play random)
		automat to compare methode of evaluation 
  
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 To contact the author:	Marc Dechico
 Kerfring
 29390 SCAER France
 tel: 06 80 83 74 99
 Mail: ec@dechico.com 
    
*/


#include "ec_global.h"


/* Type de note pour mise en tableau */
enum typ_not
{
  nbr_mvt,
  nbr_mat,
  nbr_mat_inc,
  nbr_pat,
  nbr_pat_inc,
  nbr_mat_rf,
  nbr_pat_rf,
  nbr_fou,
  mob_pie,
  cou_pie
};
/* Nombre de type de note */
#define NBR_TYP_NOT           10   

/* Sous structure de not_mvt_ini pour evaluation mat/pat par profondeur */
struct st_hst_pro_sta	
{
  int i_cam;				/* Camp jouant a cette  pro	*/
  int i_inc;				/* Si increment profondeur = 1	*/
  float f_dat_pro [NBR_TYP_NOT];	/* Data par profondeur  non pondéré */
};

/* tableau note du mvt initial */
#define ST_NOT_MVT_INI   struct	 st_not_mvt_ini  
struct st_not_mvt_ini
{
  int 	i_num_mvt;	/* Numero du mvt */
  int   i_pro_sim;		/* profondeur de simulation */	 
  int	i_inc_pro_sim;		/* incrément profondeur de simulation*/
  int 	i_cam;	  	/* cam propre */
  int 	i_cam_adv;	/* cam adverse*/
  int 	i_Id;		/* pièce mouvemente*/
  char 	c_lib_pie;      /*  libelle piece*/
  int 	i_typ_mvt;	/* type mouvement */
  int 	i_pos_ori_n;    /* pos d'origine échiquier */
  int 	i_pos_arr_n;    /* pos arrivee échiquier*/
  int 	i_nbr_rep_sit;  /* Nombre de répétition situation */
  int   i_not_pri;	/* Note prise */
  
  /* struct st_hst_pro_sta 	*/	/* statistique par profondeur */
  /*tst_pro_sta[PRO_SIM_INF_MAX]; */	/* marge de 1 poste car profondeur de depart */

  struct st_not
  {
    float f_not_cam_bru[2];  /* donnée cumulée brute(cad non pondérée) */
    float f_not_cam_pon[2];  /* note pondrée par camp  */
    float f_not_dif_pon;     /* difference pondérée pc-ca pond */
    int   i_not_pon_rec;     /* fifférence pondérée et recadrée  */
  } tst_not[NBR_TYP_NOT];

  /* Note globale */
  float f_tot_dif_pon;		/* total pondéreé de la note non recadrée */
  float	f_tot_rec_pon;       	/* total pondéré de la note recadrée */ 
};

/* indexe pour retrier les mouvement */
struct st_tri_mvt_ini
{
  ST_NOT_MVT_INI *pts_tri_rec;

};

/* structure pour evaluation rapport de force */
struct st_eva_sit
{
  int    ti_tot_for[2];        /* Totalisation force des piece par camp */
  int    i_not_for;            /* Force pc - ca */
  float  tf_cou[2];            /* Evaluation couverture par camp avant mouvement */
  float  f_cou;                /* cou pc - cou ca */
  float  tf_mob[2];             /* mobilité par camp */
  float  f_not_mob;              /* mob pc- mob ca */
  /* Pondération ou ordre de tri */
  int ti_coe_pon[NBR_TYP_NOT];

  /* maximum /minimu rencontrée ds la selction des meilleurs mvts pour cal note recadrée */

  struct st_int_not
  {
    float max;
    float min;
  } tst_int_not[NBR_TYP_NOT];


};



/* Memorisation de position des pieces detecter les cas de partie nulle */
struct st_pos
{
  int i_pos_n [2][17];		/* position cam Id  */
  int ti_roc_cam_typ[2][2];     /* [cam][type] type: 0= petit 1= grd */
  int i_cam_jou;		/* Camp qui doit jouer */
  /* info pour éviter de tester l'ensemble des pieces */
  int i_nbr_pie[2];		/* Nombre de piece par camp */
  int i_som_pos[2];		/* Somme des positions */
  int i_nbr_pie_tot;		/* Nombre de pieces total */
  int i_som_pos_tot;		/* Somme des position */
};


/* Pagination pour toutes les fonction d'affichage necessitant plus d'1 page */
/* bug find a way to declare it static without a warning messge */
struct st_aff tst_aff[st_aff_dim];

