/*  Ec      Copyright (C)   2001 Marc Dechico

    ec_global.h : a common header file where global datas and functions
		are defined. 
		(working to change most of  them to static )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: ec@dechico.com 
    
*/

#ifndef TYPES_H_   
#define TYPES_H


/* AIX requires this to be the first thing in the file.  */
#if defined (_AIX) && !defined (__GNUC__)
 #pragma alloca
#endif
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <getopt.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <errno.h>


#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_LOCALE_H
#include <locale.h>
#endif

#if ENABLE_NLS
#include <libintl.h>
#define _(String) gettext (String)
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)

#else
#define _(String) (String)
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)

#endif
#ifndef errno
extern int errno;
#endif

#ifdef	STDC_HEADERS
#include <stdlib.h>
#else	/* Not STDC_HEADERS */
extern void exit ();
extern char *malloc ();
#endif	/* STDC_HEADERS */

#ifdef	HAVE_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif

#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#ifdef HAVE_SYS_FILE_H
#include <sys/file.h>
#endif

#ifdef	__GNUC__
#undef	alloca
#define	alloca(n)	__builtin_alloca (n)
#else	/* Not GCC.  */
#ifdef	HAVE_ALLOCA_H
#include <alloca.h>
#else	/* Not HAVE_ALLOCA_H.  */
#ifndef	_AIX
extern char *alloca ();
#endif	/* Not _AIX.  */
#endif	/* HAVE_ALLOCA_H.  */
#endif	/* GCC.  */

#ifdef HAVE_SYS_PARAM_H
/* To possibly get the definition of DEV_BSIZE. */
#include <sys/param.h>
#endif
#include "system.h"

#include	<ctype.h>
#include 	<signal.h>
#include 	<time.h>  




/***************************************************/
//#include 	"ec_defin.i"

#if BORLAND_C == 1
#include 	<sys/timeb.h>
#if DOS == 1
#include <bios.h>
#endif
#else
#include 	<sys/time.h>
#endif

/* directive  compilateur */
 
/* #define BORLAND_C   0 */			/* 0 = Non 1 = OUI */
/*#define GCC	    1 */
 

#if BORLAND_C == 1
#if DOS == 1
#define ESC 27
#endif
#endif

#if LINUX  == 1
const struct sigaction st_sig_act;	/* gestion message system */ 
#endif

/* directive conditionelle por debug */
# define CPT_ITE 0		/* 1 pour inclusion du code 0 sinon */
# define CTL_DEP_ECH_PIE 0	/*  pour controle dephasage entre echiquier et piece */ 

/* Length of the full-path-file-name for save and restor */
#define LEN_FUL_PAT_FIL_NAM 100

/* Longueur message utilisateur */
#define LEN_MES 200

/* Nombre de parametre a inclure dans messages */
#define NBR_MAX_PAR_MES 10
/* Longueur maximum du parametre */
#define LON_MAX_PAR_MES 80

/* Profondeur de hst_pro */
#define PRO_HST			300
/* Nombre maximum de mouvement initiaux */
#define MVT_INI			70

/* Profondeur maximum de simulation inferieur/superieur */
#define PRO_SIM_SUP_MAX 10
#define PRO_SIM_INF_MAX 20

/* Yes No  */
enum e_yes_no 
{
	N=0,	
	Y=1
};
typedef enum e_yes_no e_yes_no;

/* type de rock */
#define PET_ROC			0
#define GRA_ROC 		1

/* Piece side  */
enum e_side 
{
	BLANC=0,	
	NOIR=1
};
typedef enum e_side  e_side;

/* Valeur possible pour  le camp */
/*
#define BLANC			0
#define NOIR    		1*/
#define VIDE                   -1
#define HOR_ECH                -2

/* Type de mouvements */
#define PAS_DE_MVT		0
/* cavalier tour fou reine  */
#define TFR_DEP			1
#define TFR_PRI			2
/* roi */
#define ROI_DEP			3
#define ROI_PRI		        4
#define ROI_GRA_ROC		5
#define ROI_PET_ROC		6
/* cavalier */
#define CAV_DEP			7
#define CAV_PRI			8
/* pion */
#define PIO_1C        		9
#define PIO_2C 	       		10
#define PIO_PRI			11
#define PIO_PRI_PAS		12

#define PIO_PRO_REI	        13
#define PIO_PRO_FOU	        14
#define PIO_PRO_TOU	        15
#define PIO_PRO_CAV	        16

#define PIO_PRO_REI_PRI	        17
#define PIO_PRO_FOU_PRI	        18
#define PIO_PRO_TOU_PRI	        19
#define PIO_PRO_CAV_PRI	        20

#define NBR_TYP_MVT             21

/* */
#define NOT_MIN        -32768    /* le plus grand nombre negatif pour le type int */
#define NOT_ROC_TOU      -1    /* empecher le roc  */

#define FOR_PIO           10
#define FOR_CAV           30
#define FOR_FOU           50
#define FOR_TOU           70
#define FOR_REI          200
#define FOR_ROI            1     /* pour analyse couverture */
#define NOT_MAT              900
#define RAP_FOR_LIM_CUT       80     /* rapport de force limite au dessu duquel on arrete la descente (cut)*/  


/* NOT_MAT_MIN est un seuil:
	au dessus on est certain que la note represente un mat et ce malgre le decrement de 10
	par profondeur (900 - 10 * 40 mvt successif )=500. La machine capable d'analyser sur une 
	prfondeur de 40 mvt n'existe pas encore.

	au dessous la note represente seulement des prises de piece car si toutes les piece etaient prises
	la note ne depasserai pas 400.

	La not d'une branche comportant un mat n'inclura plus les eventuelle prises de cette branche pour 
	pouvoir aller le plus rapidement au mat s'il est inevitable.
	
	On pourra savoir en combien de mvt successifs le mat inevitable pourra avoir lieu avec:
	Nbr mvt = (NOT_MAT - note)/10.
	cad si note = 880 mat inevitable en 2 coups.  
 
*/
#define NOT_MAT_MIN      500   

/* libelle colone <-> N de colonne */
#define A              1
#define B              2
#define C              3
#define D              4
#define E              5
#define F              6
#define G              7
#define H              8

/* libelle case <-> numero de case  */
#define A1              11
#define A2              21 
#define A3              31
#define A4              41
#define A5              51
#define A6              61
#define A7              71
#define A8              81

#define B1              12
#define B2              22
#define B3              32
#define B4              42
#define B5              52
#define B6              62
#define B7              72
#define B8              82

#define C1              13
#define C2              23
#define C3              33
#define C4              43
#define C5              53
#define C6              63
#define C7              73
#define C8              83

#define D1              14
#define D2              24
#define D3              34
#define D4              44
#define D5              54
#define D6              64
#define D7              74
#define D8              84

#define E1              15
#define E2              25
#define E3              35
#define E4              45
#define E5              55
#define E6              65
#define E7              75
#define E8              85

#define F1              16
#define F2              26
#define F3              36
#define F4              46
#define F5              56
#define F6              66
#define F7              76
#define F8              86

#define G1              17
#define G2              27
#define G3              37
#define G4              47
#define G5              57
#define G6              67
#define G7              77
#define G8              87

#define H1              18
#define H2              28
#define H3              38
#define H4              48
#define H5              58
#define H6              68
#define H7              78
#define H8              88

/* Modification de coordonnee roi, reine, fou, tour */
#define HH             +=10              /* haut        1 case */
#define HD             +=11              /* haut droite 1 case */
#define DD             +=1               /* droite      1 case */
#define BD             -=9               /* bas droite  1 case */
#define BB             -=10              /* bas         1 case */
#define BG             -=11              /* bas gauche  1 case */
#define GG             -=1               /* gauche      1 case */
#define HG             +=9               /* haut gauche 1 case */

#define _HH             +=10              /* haut        1 case */
#define _HD             +=11              /* haut droite 1 case */
#define _DD             +=1               /* droite      1 case */
#define _BD             -=9               /* bas droite  1 case */
#define _BB             -=10              /* bas         1 case */
#define _BG             -=11              /* bas gauche  1 case */
#define _GG             -=1               /* gauche      1 case */
#define _HG             +=9               /* haut gauche 1 case */


/* Modification de coordonnee cavalier */
#define CHD             +=21              /* cavalier haut droite */
#define CDH             +=12              /* cavalier droite haut */
#define CDB             -=8               /* cavalier droite bas  */
#define CBD             -=19              /* cavalier bas droite  */
#define CBG             -=21              /* cavalier bas gauche  */
#define CGB             -=12              /* cavalier gauche bas  */
#define CGH             +=8               /* cavalier gauche haut */
#define CHG             +=19              /* cavalier haut gauche */

/* Modification de coordonnee pion blanc */
#define PH1            +=10              /* pion haut 1        */
#define PH2            +=20              /* pion haut 2        */
#define PHG            +=9               /* pion haut gauche   */
#define PHD            +=11              /* pion haut droite   */

#define PB1            -=10              /* pion bas 1         */
#define PB2            -=20              /* pion bas 2         */
#define PBG            -=11              /* pion bas gauche    */
#define PBD            -=9               /* pion bas droite    */


/* Message d'erreur */
enum e_msg_nbr 
{
      MSG_CHA_MES_LON_MSG		,
      MSG_CHO_COT_INV			,
      MSG_CHO_INC_INV			,
      MSG_CHO_NIV_INC_INV		,
      MSG_CHO_NIV_INV			,
      MSG_EXI_MVT_INI_NON		,
      MSG_JOU_CTFR_ROI_ECH		,
      MSG_JOU_GRD_ROC_ROC_IMP		,
      MSG_JOU_INT_COL_ARR_INV		,
      MSG_JOU_INT_COL_DEP_INV		,
      MSG_JOU_INT_LIG_ARR_INV		,
      MSG_JOU_INT_LIG_DEP_INV		,
      MSG_JOU_PAS_DE_PIE		,
      MSG_JOU_PAS_VOT_TOU		,
      MSG_JOU_PET_ROC_ROC_IMP		,
      MSG_JOU_PIB_2CA_IMP		,
      MSG_JOU_PIB_ARR_OCC		,
      MSG_JOU_PIB_INT_OCC		,
      MSG_JOU_PIB_MVT_IMP		,
      MSG_JOU_PIB_PAS_PIE_PRI		,
      MSG_JOU_PIN_2CA_IMP		,
      MSG_JOU_PIN_MVT_IMP		,
      MSG_JOU_PIO_PIE_PRO_INV		,
      MSG_JOU_PIO_ROI_ECH		,
      MSG_JOU_POS_REP_P3F		,
      MSG_JOU_PRI_PRO_CAM		,
      MSG_JOU_ROI_GRD_ROC_IMP		,
      MSG_JOU_ROI_PET_ROC_IMP		,
      MSG_JOU_ROI_ROI_ECH		,
      MSG_MVT_CAV_MVT_IMP		,
      MSG_MVT_FOU_MVT_IMP		,
      MSG_MVT_FOU_SAU_PIE		,
      MSG_MVT_REI_MVT_IMP		,
      MSG_MVT_REI_SAU_PIE		,
      MSG_MVT_ROI_MVT_IMP		,
      MSG_MVT_TOU_MVT_IMP		,
      MSG_MVT_TOU_SAU_PIE		,
      MSG_PAS_COU_PRE			,
      MSG_RST_DSK_ERR_DON		,
      MSG_RST_DSK_ERR_FIC		,
      MSG_SAV_DSK_ERR_FIC		,
      MSG_SIMU_HST_SIZ			,
      MSG_SIMU_MAT_BLANC		,
      MSG_SIMU_MAT_NOIR			,
      MSG_SIMU_PAT_BLANC		,
      MSG_SIMU_PAT_NOIR			,
      MSG_TYP_LIB_CAV			,
      MSG_TYP_LIB_REI			,
      MSG_VER_AFF_NOT_IMP		,
      MSG_VER_CHO_PRO_PIO		,
      MSG_NBR  	
};
#define TRUE  1
#define FALSE 0

/************************************************************/
/* variable test */
# if CPT_ITE == 1
unsigned long int cpt;
# endif
/* tableau correspondance posx <-> libelle colonne */
static const char tc_lib_cas[100] [3]=
{
  /* 0 */ "  ",
  /* 1 */"  ",
  /* 2 */ "  ",
  /* 3 */ "  ",
  /* 4 */ "  ",
  /* 5 */ "  ",
  /* 6 */ "  ",
  /* 7 */ "  ",
  /* 8 */ "  ",
  /* 9 */ "  ",

  /* 10 */ "  ",
  /* 11 */ "A1",
  /* 12 */ "B1",
  /* 13 */ "C1",
  /* 14 */ "D1",
  /* 15 */ "E1",
  /* 16 */ "F1",
  /* 17 */ "G1",
  /* 18 */ "H1",
  /* 19 */ "  ",

  /* 20 */ "  ",
  /* 21 */ "A2",
  /* 22 */ "B2",
  /* 23 */ "C2",
  /* 24 */ "D2",
  /* 25 */ "E2",
  /* 26 */ "F2",
  /* 27 */ "G2",
  /* 28 */ "H2",
  /* 29 */ "  ",

  /* 30 */ "  ",
  /* 31 */ "A3",
  /* 32 */ "B3",
  /* 33 */ "C3",
  /* 34 */ "D3",
  /* 35 */ "E3",
  /* 36 */ "F3",
  /* 37 */ "G3",
  /* 38 */ "H3",
  /* 39 */ "  ",

  /* 40 */ "  ",
  /* 41 */ "A4",
  /* 42 */ "B4",
  /* 43 */ "C4",
  /* 44 */ "D4",
  /* 45 */ "E4",
  /* 46 */ "F4",
  /* 47 */ "G4",
  /* 48 */ "H4",
  /* 49 */ "  ",

  /* 50 */ "  ",
  /* 51 */ "A5",
  /* 52 */ "B5",
  /* 53 */ "C5",
  /* 54 */ "D5",
  /* 55 */ "E5",
  /* 56 */ "F5",
  /* 57 */ "G5",
  /* 58 */ "H5",
  /* 59 */ "  ",
	
  /* 60 */ "  ",
  /* 61 */ "A6",
  /* 62 */ "B6",
  /* 63 */ "C6",
  /* 64 */ "D6",
  /* 65 */ "E6",
  /* 66 */ "F6",
  /* 67 */ "G6",
  /* 68 */ "H6",
  /* 69 */ "  ",

  /* 70 */ "  ",
  /* 71 */ "A7",
  /* 72 */ "B7",
  /* 73 */ "C7",
  /* 74 */ "D7",
  /* 75 */ "E7",
  /* 76 */ "F7",
  /* 77 */ "G7",
  /* 78 */ "H7",
  /* 79 */ "  ",

  /* 80 */ "  ",
  /* 81 */ "A8",
  /* 82 */ "B8",
  /* 83 */ "C8",
  /* 84 */ "D8",
  /* 85 */ "E8",
  /* 86 */ "F8",
  /* 87 */ "G8",
  /* 88 */ "H8",
  /* 89 */ "  ",

  /* 90 */ "  ",
  /* 91 */ "  ",
  /* 92 */ "  ",
  /* 93 */ "  ",
  /* 94 */ "  ",
  /* 95 */ "  ",
  /* 96 */ "  ",
  /* 97 */ "  ",
  /* 98 */ "  ",
  /* 99 */ "  "	
};

/**********************************************************************/
/*  structure enum type def for global data                           */
/**********************************************************************/
/* fonction mouvement */
typedef void (*tpf_xxx)(void);
typedef void (*def_tpf_res_pie) (void);
typedef int (*def_tpf_cas_ctl[19])     (int n,int i_cam_adv);
typedef const int def_ti_ech_dir_rei[100][100];
typedef const int def_ti_ech_dir_tou[100][100];
typedef const int def_ti_ech_dir_fou[100][100];
typedef const int def_ti_ech_dir_cav[100][100];
typedef const int def_ti_ech_dir_roi[100][100];
typedef const int def_ti_ech_dir_pio_noi[100][100];
typedef const int def_ti_ech_dir_pio_bla[100][100];
typedef const int def_ti_ech_dir_inc[100][100];

/*   tableau des pièces un par camp  */
/* opti: voir si un seul tableau possible */
struct st_pie
{
  int i_Id;				/* Id de la piece */	
  int i_pie_sui;		        /* pièce suivante */
  int i_pie_pre;                        /* pièce precedente  */
  int i_pos_n;                          /* position échiquier  */
  int i_for; 			        /* force  */
  int i_big_inc_ene;                    /* force incrementé pour eviter sacrifice inutile de piece */
  int i_big_inc_pro;                    /* force incrementé pour eviter sacrifice inutile de piece */
  int i_lit_inc_ene;                    /* force incrementé pour eviter sacrifice inutile de piece */
  int i_lit_inc_pro;                    /* force incrementé pour eviter sacrifice inutile de piece */
  char c_lib_pie;			/* Libelle piece  */
  char c_typ_pie;			/* Type  piece  */
  void (*pf_ini_hst_mvt) (void);	/* ptr sur fonction in_mvt_XXX   */
  int (*pf_jou)  (char c_rem_pio);	/* ptr sur fonction joue pièce	 */
      
  int (*pf_ech_par) (int n,int nr);     /* ptr sur fonction echec par  */
  int (*pf_ctl_par) (int n,int nr);     /* ptr sur fonction cas_tl_xxx  */
  e_yes_no e_mvt_uni_dir ;    	        /* mvt unique pour direction   */
  e_yes_no e_typ_mvt_tou ;              /* type de mvt selon colone oui = 1 pour reine et tour */   
  e_yes_no e_typ_mvt_fou ;              /* type de mvt selon oblique oui= 1 pour reine et fou */

};

/* tableau echiquier accès par l'emplacement  */
struct st_ech
{
  int i_cam;
  /* opti perf: pourrait peut etre utiliser une adresse sur piece */ 
  int i_Id;
};

/* tableau historique des coups */
struct st_hst_pro
{
  int i_pro;			        /* profondeur pour test du ptr pts_hst_pro 0= debut de partie */
  int i_dec_mat;		        /* décrement pour la note mat */
  e_yes_no e_exp_par;                   /* rester au même niveau si deplacement suit une prise */
  const  tpf_xxx *ptpf_mvt;	        /* ptr sur fonction  mouvement */
  int i_cam;    	 	        /* camp	*/
  struct st_pie *pts_pie_pc;            /* pointeur sur piece propre camp  */        
  e_yes_no e_ene;                       /* Yes if adversary */
  int i_cam_adv;	         	/* camp	 adverse */
  struct st_pie *pts_pie_ca;            /* pointeur sur piece camp adverse */
  int i_Id;                 	        /* Idetifiant pièce */
  /* opti : voir si stockage de l'adresse serait pas plus performant */
  int i_pos_n;                 	        /* pos. échiquier*/
  int i_typ_mvt;		        /* type mouvement */
  e_yes_no e_dir_sui;		        /* direction suivante*/
  int i_pos_ori_n;                      /* pos. origine	*/
  int i_Id_2p;                          /* Id deuxième pièce */
  int i_pos_n_R_p_c;	                /* Position n roi propre camp	*/
  int i_pos_n_R_c_a;	                /* Position n roi camp	adverse	*/
  e_yes_no e_ech ;		        /* echec par pièce principale 
                                           ou secondaireou par demasquge */
  int i_ech_dir_pri;	                /* dir. pièce principale ou secondaire
                                            causant echec sur camp adverse
				           (si valeur  <> 0 alors echec) */
  int i_ech_dir_dem;	                /* dir.demasaquage causant eventuel
				           echec sur camp  adverse  */
  int i_ech_dir_dem_p_c;                /* direction demasaquage causant echec	
				           sur propre camp  */
  e_yes_no e_pat ;    	         	/* pat   */
  e_yes_no e_mat ;	        	/* mat 	*/
  /*  int ti_not[2];  */                /* note par camp */
  int i_not;		        	/* note */
  int i_not_max;		        /* note maximum */
  int i_rap_for;                        /* rapport de force à zero en debut de simu */
  int ti_roc_cam_typ[2][2];             /* [cam][type] type: 0= petit 1= grd 
                                           Si = 1 alors piece deplacé
                                           bug Suppression non signalé*/
  unsigned long int uli_cpt_cou;        /* Compteur de coup */
  unsigned long int uli_cpt_mat;        /* Compteur de mat */
  unsigned long int uli_cpt_pat;        /* Compteur de pat */
  unsigned long int uli_cpt_mat_rf;     /* Compteur de mat rapport de force = 0 */
  unsigned long int uli_cpt_pat_rf;     /* Compteur de pat rapport de force = 0 */
  unsigned long int uli_nbr_fou;        /* Compteur de fouchettes */
  int i_nbr_pri_pie;                    /* Compteur de prises faites par une piece 
				           raz à chaque chgt de piece */
  /* variable test */
# if CPT_ITE == 1
  unsigned long int cpt;
# endif
};



/* Table des messages utilisateur */
/*char tc_msg_txt[NBR_MSG][LEN_MES];*/
typedef char *def_tptc_msg[MSG_NBR];

/* strucuture parametre messages */
struct st_par
{
  int i_nbr_par;                /* nombre de parametres */
  char tc_par_mes [NBR_MAX_PAR_MES][LON_MAX_PAR_MES];
};

enum {e_pas_aff,e_aff_not_1,e_aff_not_2,st_aff_dim} e_cur_aff;		/* affichage en cours */

/* used be able to print result in several page  with teletype mode */
struct st_aff
{
  int i_nbr_lig_pag;
  int i_cur_pag;
  int i_fir_pag;
  int i_las_pag;
  int (*pf_aff)();
  void * arguments;
};

/* to avoid multiple inclusion of this entire file */
#endif
