/*   
     
Ec    Copyright (C)   2001 Marc Dechico


 ec_memlst.c: Memmory liste .
   
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 To contact the author:	Marc Dechico
 Kerfring
 29390 SCAER France
 tel: 06 80 83 74 99
 Mail: ec@dechico.com 


 Manage linked-listes to register subsequent allocated memory in order to free
 it all later through only one function.
 Several Memmory liste can be created.and it's meant to be thread safe.
 Each time memmory is allocated you register it in the liste with  the function 
 mem_lst_add.
 when all this memory isn't usefull anymore, just call 
 mem_lst_free 
 that will free all the memmory registered in the liste and also the 
 one used for the memory liste.
 
 (I didn't write the book about memory allocation and thread)
 (I am not shure it will be usefull)    
*/

#include "ec_memlst.h"
/* structure used to register the allocated memmory (as an index) */ 
struct st_ind
{
  void * pv_mem;               /* pointer on the memory registered*/
  struct st_ind *pst_pre_ind;  /* link to previous index*/
} ;

int mem_lst_ini  (struct st_ind  **ppst_cur_ind);
int mem_lst_add  (struct st_ind  **pst_cur_ind, void * p_new_mem);
int mem_lst_fre  (struct st_ind  **ppst_cur_ind);
int mem_lst_lst  (struct st_ind  *pst_cur_ind);

int 
mem_lst_ini (struct st_ind **ppst_cur_ind)
{
  *ppst_cur_ind = NULL;
  return 0;
}
int 
mem_lst_add (struct st_ind  **ppst_cur_ind, void * pv_new_mem)
{
  /* create a new index for the new memory bloc allocated */

  struct st_ind *pst_new_ind;

  pst_new_ind = malloc(sizeof(struct st_ind));
  if (pst_new_ind == NULL) 
    return 1;
  else
    {
      pst_new_ind->pst_pre_ind=*ppst_cur_ind;
      pst_new_ind->pv_mem=pv_new_mem;
      *ppst_cur_ind=  pst_new_ind;


    }
  return 0;
}

int 
mem_lst_fre (struct st_ind **ppst_cur_ind)
{
  /* free the adresses memorized in the memmory liste and
     also the memory allocated by the memmory liste himself */
  struct st_ind *pst_cur_ind, *pst_cur_ind_sv;
  pst_cur_ind=*ppst_cur_ind;
  while (pst_cur_ind != NULL)
    {
      if (pst_cur_ind->pv_mem!=NULL)
	free(pst_cur_ind->pv_mem);
      pst_cur_ind_sv=pst_cur_ind;

      pst_cur_ind=pst_cur_ind->pst_pre_ind;

      if (pst_cur_ind_sv != NULL)
	free(pst_cur_ind_sv);

    }
  *ppst_cur_ind=NULL;
  return 0;

}
int mem_lst_lst (struct st_ind *pst_cur_ind)
{
    /* liste the adresses memorized  and value for debugging */
  int i;
  void *pv_mem;
  /*  void mem;*/
  struct st_ind *pst_cur_ind_ww;
  pst_cur_ind_ww=pst_cur_ind;
  while (pst_cur_ind_ww != NULL)
    {
      if (pst_cur_ind_ww->pv_mem!=NULL)
	{
	  pv_mem=pst_cur_ind_ww->pv_mem;
	  /* mem=*pv_mem;*/
	  i= * (int *) pv_mem;

	  printf("\n Memory adr %d value %d",(int)pst_cur_ind_ww,i);
	}
      pst_cur_ind_ww=pst_cur_ind_ww->pst_pre_ind;
    }
return 0;
}
